package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.scale.dao.model.ScaleEntity;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @description 你给人的第一印象如何？
 */
public class YFIScale extends BaseScale {

    public YFIScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public JSONObject scaleCalculate() throws Exception {

        //总分
        int score = 0;

        List<ScaleEntity> scaleEntities = (List<ScaleEntity>) resultJson.get("scaleEntities");

        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("scoreDirection").equals("1")) {
                String[] split = scaleEntities.get(i).getCheckItems().split("；");
                for (int y = 0; y < split.length; y++) {
                    if (jsonObject1.getString("checkItems").equals(split[y])) {
                        switch (y) {
                            case 0: {
                                score += 1;
                                break;
                            }
                            case 1: {
                                score += 3;
                                break;
                            }
                            case 2: {
                                score += 5;
                                break;
                            }
                        }
                    }
                }
            } else if (jsonObject1.getString("scoreDirection").equals("0")) {
                String[] split = scaleEntities.get(i).getCheckItems().split("；");
                for (int y = 0; y < split.length; y++) {
                    if (jsonObject1.getString("checkItems").equals(split[y])) {
                        switch (y) {
                            case 0: {
                                score += 5;
                                break;
                            }
                            case 1: {
                                score += 3;
                                break;
                            }
                            case 2: {
                                score += 1;
                                break;
                            }
                        }
                    }
                }
            }
        }



        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));

        resultJson.put("总分", String.valueOf(score));

        if (score >= 0 && score <= 22) {
            resultMap.put("总分结论", "你给人留下的第一印象不太好。是不是很吃惊？可能你觉得只是按照自己的兴趣习惯做事。虽然也许你本人也极愿意给别人留下好的印象，可是，你的各方面传达出漫不经心、言语无味的信号，所以别人会觉得你给他(她)留下的印象不是很好。必须记住，与人交往是一门艺术，艺术是要经过修饰的。");
            resultJson.put("总分结论", "你给人留下的第一印象不太好。是不是很吃惊？可能你觉得只是按照自己的兴趣习惯做事。虽然也许你本人也极愿意给别人留下好的印象，可是，你的各方面传达出漫不经心、言语无味的信号，所以别人会觉得你给他(她)留下的印象不是很好。必须记住，与人交往是一门艺术，艺术是要经过修饰的。");
        } else if (score >= 23 && score <= 46) {
            resultMap.put("总分结论", "你给人留下的第一印象一般。你的表现，有些部分让人很愉快，不过，也有不太好的地方，这不会让人对你产生厌恶感，不过，也不会让别人觉得你很有魅力。如果你希望提高自己的魅力，首先必须从心理上重视，努力在“交锋”的第一回合显示出最佳形象。");
            resultJson.put("总分结论", "你给人留下的第一印象一般。你的表现，有些部分让人很愉快，不过，也有不太好的地方，这不会让人对你产生厌恶感，不过，也不会让别人觉得你很有魅力。如果你希望提高自己的魅力，首先必须从心理上重视，努力在“交锋”的第一回合显示出最佳形象。");
        } else if (score >= 47 && score <= 60) {
            resultMap.put("总分结论", "你给人留下的第一印象非常好。你得体的体态、温和的谈吐，合作的精神，给第一次见到你的人留下了深刻的印象。无论对方是你工作范围内的人抑或是你私人社交生活中的接触者，他们都有与你进一步接触的愿望。");
            resultJson.put("总分结论", "你给人留下的第一印象非常好。你得体的体态、温和的谈吐，合作的精神，给第一次见到你的人留下了深刻的印象。无论对方是你工作范围内的人抑或是你私人社交生活中的接触者，他们都有与你进一步接触的愿望。");
        }


        List<Map<String, String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_YFI);
        returnJson.put("resultJson", resultJson);

        return returnJson;
    }
}
